//
// jot - Text Editor for Windows Mobile
//   Copyright (C) 2007-2008, Aquamarine Networks.  <http://pandora.sblo.jp/>
//
//    This program is EveryOne's ware; you can redistribute it and/or modify it 
//    under the terms of the NYSL version 0.9982 or later. <http://www.kmonos.net/nysl/>
//

#include "stdafx.h"

#include "txt.h"

#define	BUFF_BLOCK	4096
//--------------------------------------------------------

charset Txt::autoDetect(const TCHAR *fname, lbcode* lb)
{
	FileR f;
	if(!f.open( fname )) return charset(0);

	// ܂
	charset        cs = charset(0);
	const int maxlen = 65536*2;
	size_t  uppersize = f.size() > maxlen ? maxlen : f.size();

	// LineBreak `FbN
	*lb = checkMultiLB( f.base() , uppersize );

	// BOM check	// BOMΊm
	if( f.size()>4 )
		if(charset(0) != (cs = checkBOM(f)) )
			return cs;
	// sR[h`FbN
	if( charset(0) != (cs = checkUtf16(f.base() , uppersize) ) )
		return cs;


	// UTF8Ŏǂ
	{
		// UTF8 ƂĐȂ trueB
		// Â܂܂ƁApp݂̂̃t@C
		// UTF8N ƂĔFĂ܂ -> łH
		const UCHAR *p = f.base();
		const ULONG _size = uppersize;
		bool utf8=true;	
		for( size_t i=0; i+4<_size; )
		{
			if( (*p&0x80)==0x00 ){ p++; i++; continue; }
			else if( (*p&0xE0)==0xC0 && ((*(p+1))&0xC0)==0x80 )
			{ p+=2; i+=2; continue; }
            else if( (*p&0xF0)==0xE0 && ((*(p+1))&0xC0)==0x80 
                     && ((*(p+2))&0xC0)==0x80 )
			{ p+=3; i+=3; continue; }
			else if( (*p&0xF8)==0xF0 && ((*(p+1))&0xC0)==0x80 
				&& ((*(p+2))&0xC0)==0x80 && ((*(p+3))&0xC0)==0x80 )
			{ p+=4; i+=4; continue; }
			else { 
				utf8=false;
				break;
			}
		}
		if ( utf8 ){
			cs = UTF8N;
		}
	}


	// EUC - JIS - SJIS `FbN
	const UCHAR* p = f.base();

	int cEucjp=0;
	int cSjis=0;
	int diff;
	for( size_t pos1=0; pos1+3<uppersize; p++, pos1++ )
	{
		int pt = checkCharCode(p);

		// IsoJP͎ʂłΈꔭŊm
		if( pt >=16            ){
			cs = IsoJP;
			break; 
		}
		// EUCۂ̓JE^
		if( cs == charset(0) && pt >=4 && pt <= 15 ){
			cEucjp++;
		}
		// SJISۂJE^
		if( cs == charset(0) && pt >=2 && pt <= 3  ){ 
			cSjis++;
		}
		// EUCSJIS̍32ȏJm
		diff = cEucjp - cSjis;
		if ( diff > 32 ){
			cs = EucJP; 
			break; 
		}else if (diff < -32 ){
			cs = SJIS;  
			break; 
		}
	}
	// ܂łŌ܂ȂAɂ
	if ( cs == charset(0) ){
		if ( diff > 0 ){
			cs = EucJP; 
		}else{
			cs = SJIS;  
		}
	}

	//// ǂɂYȂƂ肠 SJIS
	//if( cs==charset(0) ) cs = SJIS;

	//// LB `FbNvȂȂ炱 return
	//if( lb==NULL ) return cs;

	return cs;
}

charset Txt::checkBOM(FileR& f)
{
	const UCHAR* p = (const UCHAR*)(f.base());
	//UTF-8 signature:      EF BB - BF
	//UTF-16(LE) signature: FF FE
	//UTF-16(BE) signature: FE FF
	if( p[0]==0xff && p[1]==0xfe )
		// UTF-16LE
		return UTF16l;
	else if( p[0]==0xfe && p[1]==0xff )
		// UTF-16BE
		return UTF16b;
	else if( p[0] == 0xEF && p[1] == 0xBB && p[2] == 0xBF )
		// UTF-8
		return UTF8;

	return charset(0);
}

Txt::lbcode Txt::checkMultiLB(const UCHAR *base, const ULONG size)
{
	UINT i=0;
	const UCHAR *p=base;
	const USHORT *ps;
	while( i < size )
	{
		// 2 byte
		if( (i%2)==0 && i+1 < size )
		{
			ps = reinterpret_cast<const USHORT*>(&p[i]);
			if( *ps==0x000a || *ps==0x0a00 ) return LF;
			if( *ps==0x000d || *ps==0x0d00 )
			{
				ps = reinterpret_cast<const USHORT*>(&p[i+2]);
				if( *ps==0x000a || *ps==0x0a00 ) return CRLF;
				else                             return CR;
			}
		}

		// 1 byte
		if(p[i]=='\r'){
			if(p[i+1]=='\n') return CRLF;
			else             return CR;
		}else if(p[i]=='\n') return LF;

		i++;
	}
	return CRLF;
}

charset Txt::checkUtf16(const UCHAR *base, const ULONG size)
{
	UINT i=0;
	const USHORT *ps=(const USHORT*)base;
	while( i+1 < size/2 )
	{
		if ( *ps==0x000a || *ps==0x000d ) return UTF16LE;
		if ( *ps==0x0a00 || *ps==0x0d00 ) return UTF16BE;
		i++;
		ps++;
	}
	return charset(0);
}

/*
̎ʂ\l
Estr̐擪pJȉꍇA֐l1
Estr̐擪2VtgJISR[h̏ꍇA֐l2
Estr̐擪2EUCpJiR[h̏ꍇA֐l4
Estr̐擪2EUCSpR[h̏ꍇA֐l8
Estr̐擪3VJIS(X0208-1983)VtgR[h̏ꍇA
@֐l16
Estr̐擪3JIS(X0208-1978)VtgR[h̏ꍇA
@֐l32
Estr̐擪3JIS[}(X0201)VtgR[h̏ꍇA
@֐l64
Estr̐擪3ASCII VtgR[h̏ꍇA֐l128
ẼP[XɋNꍇ́A֐l̘͂_a
ÊłȂꍇ́A֐l0
*/
int Txt::checkCharCode(const unsigned char* str)
{
	int val = 0;
	unsigned char b1, b2, b3;

	b1 = *str++;
	b2 = *str++;
	b3 = *str;
	if (b1 == 0x1b) {
		if (b2 == '$' && b3 == 'B') return 16;
		if (b2 == '$' && b3 == '@') return 32;
		if (b2 == '(' && b3 == 'J') return 64;
		if (b2 == '(' && b3 == 'B') return 128;
		return 0;
	}
	if ( b1 >= 0xa0 && b1 <= 0xdf) val |= 1;
	if ((b1 >= 0x81 && b1 <= 0x9f ||
		 b1 >= 0xe0 && b1 <= 0xfc) && 
		 (b2 >= 0x40 && b2 <= 0xfc && b2 != 0x7f)){
			 val |= 2;
	}
	if (b1 == 0x8e && (b2 >= 0xa0 && b2 <= 0xdf)) val |= 4; 
	if ((b1 >= 0xa1 && b1 <= 0xfe) &&
		(b2 >= 0xa1 && b1 <= 0xfe)) val |= 8;

	return val;
}

//--------------------------------------------------------

TxtDecoder::TxtDecoder(int charset)
     :_charset(charset),_buff(NULL),_state(0),_buffsize(0)
{}

TxtDecoder::~TxtDecoder()
{
	close();
	DELA( _buff );
}

bool TxtDecoder::open(const TCHAR* fname)
{
	if( !_fp.open(fname) ) return false;

	// {IɉsR[h͎ʁB
	// 

	_pos = 0;
	_base = _fp.base();
	_size = _fp.size();
	_state = 1;

	return true;
}

void TxtDecoder::close()
{
	_fp.close();
}


void	TxtDecoder::MbsToWcs( UINT CodePage )
{
	// EOF ܂ŗ _state  0 ɂ
	const UCHAR *p = &_base[_pos];
	size_t start = _pos, length=0;
	_state = 1;
	while(1){
		if( _pos>=_size ){
			_state = 0;
			break;
		}
		if( *p=='\n' ){
			_pos++;
			break;
		}else if( *p=='\r' ){
			_pos++;
			if( p[1]=='\n' ){ 
				_pos++;
			}
			break;
		}
		p++;
		_pos++;
		length++;
	}

	// }`oCg烏Chւ̕ϊŃoCgƂƂ͂Ȃ̂
	// oCgƂăobt@mۂ
	int bufflen = length;			

	if ( bufflen+1 > _buffsize ){
		DELA( _buff );
		_buffsize = bufflen+1+BUFF_BLOCK;
		_buff = new TCHAR[_buffsize];
	}

	const char* spos = (const char*)_base+start;

	switch( _charset ){
	case SJIS:
		bufflen = MultiByteToWideChar(CP_ACP , 0,	spos , length,	_buff, bufflen );
		break;
	case EucJP:
		{
			EucTxt	euc;
			int		sjislen=0;
			char	*sjis = euc.ToSjis( spos , length , sjislen );	// EUC->SJISɕϊ
			bufflen = MultiByteToWideChar(CP_ACP , 0,	sjis , sjislen,	_buff, bufflen );
		}
		break;
	case IsoJP:
		{
			Iso2022Txt	jis;
			int		sjislen=0;
			char	*sjis = jis.ToSjis( spos , length , sjislen );	// EUC->SJISɕϊ
			bufflen = MultiByteToWideChar(CP_ACP , 0,	sjis , sjislen,	_buff, bufflen );
		}
		break;
	case UTF8:		// Unicode  (UTF-8): BOML
	case UTF8N:		// Unicode  (UTF-8): BOM
		bufflen = MultiByteToWideChar(CP_UTF8, 0,	spos , length,	_buff, bufflen );
		break;
	case Latin:
		bufflen = MultiByteToWideChar(1252 , 0,	spos , length,	_buff, bufflen );
		break;
	}


	_buff[bufflen]=_T('\0');
}

TCHAR	TxtDecoder::ChangeEndian( USHORT wc , bool  le )
{
	// rbOGfBA̎HLւ
	if ( !le ){
		wc = MAKEWORD( HIBYTE(wc) , LOBYTE(wc) );
	}
	return wc;
}

void	TxtDecoder::Utf16ToWcs( bool le)
{
	// EOF ܂ŗ _state  0 ɂ
	const USHORT *p = (const USHORT*)&_base[_pos];
	size_t start = _pos, length=0;
	_state = 1;
	while(1){
		if( _pos>=_size ){
			_state = 0;
			break;
		}
		USHORT	wc = ChangeEndian( *p , le );
		if( wc==0x000A ){
			_pos+=2;
			break;
		}else if( wc==0x000d ){
			_pos+=2;
			if( ChangeEndian( p[1] , le )==0x000a ){ 
				_pos+=2;
			}
			break;
		}
		p++;
		_pos+=2;
		length++;
	}
	int bufflen = length;
	_buff = new TCHAR[bufflen+1];

	p = (const USHORT*)&_base[start];
	for( size_t i=0;i<length;i++){
		_buff[i] = ChangeEndian( p[i], le );
	}
	_buff[bufflen]=_T('\0');
}


TCHAR	*TxtDecoder::readLine()
{
	//if ( _buff!=NULL ){
	//	DELA(_buff);
	//	_buff = NULL;
	//}

	switch( _charset ){
	case UTF8:		// Unicode  (UTF-8): BOML
		if( _pos==0 ) _pos = 3;
	case UTF8N:		// Unicode  (UTF-8): BOM
	case SJIS:
	case EucJP:
	case IsoJP:
	case Latin:
		MbsToWcs( _charset );
		break;
	case UTF16b:    // Unicode  (UTF-16)  : BOML BE
		if( _pos==0 ) _pos = 2;
	case UTF16BE:   // Unicode  (UTF-16BE): BOM
		Utf16ToWcs( false);
		break;
	case UTF16l:    // Unicode  (UTF-16)  : BOML LE
		if( _pos==0 ) _pos = 2;
	case UTF16LE:   // Unicode  (UTF-16LE): BOM
		Utf16ToWcs( true);
		break;
	}
	return _buff;
}



//--------------------------------------------------------

TxtEncoder::TxtEncoder(int charset, int linebreak)
     :_charset(charset),_lb(linebreak),_buff(NULL),_buffsize(0)
{}

TxtEncoder::~TxtEncoder()
{
	DELA( _buff );
}

bool TxtEncoder::open(const TCHAR *fname)
{
	if( !_fp.open(fname) ) return false;

	return true;
}

void TxtEncoder::close()
{
	_fp.close();
}

void TxtEncoder::writeBOM( )
{
	switch ( _charset ){
	case UTF8:      // Unicode  (UTF-8)   : BOML
		{
			const UCHAR p[3] = {0xef, 0xbb, 0xbf};
			_fp.write( (const void*)p, 3);
		}
		break;
	case UTF16b:    // Unicode  (UTF-16)  : BOML BE
        {
			const UCHAR p[2] = {0xfe, 0xff};
			_fp.write( (const void*)p, 2);
        }
		break;
	case UTF16l:    // Unicode  (UTF-16)  : BOML LE
        {
			const UCHAR p[2] = {0xff, 0xfe};
			_fp.write( (const void*)p, 2);
        }
		break;
	}
}

void TxtEncoder::writeLB( )
{
	switch( _charset ){
	case SJIS:
	case EucJP:
	case IsoJP:
	case UTF8:
	case UTF8N:
	case Latin:
		{
			// CR, LF, CRLF
			const USHORT lbstr[] = { 0x0d, 0x0a, 0x0a0d };
			const    int lblen[] = {    1,    1,      2 };

			_fp.write( (const void *)&lbstr[_lb-1], lblen[_lb-1] );
		}
		break;

	case UTF16b:    // Unicode  (UTF-16)  : BOML BE
	case UTF16BE:   // Unicode  (UTF-16BE): BOM
		{
			const int lblen[] = { 2, 2, 4 };
			// CR, LF, CRLF
			const USHORT lbstr[]={0x0D00, 0x0A00, 0x0D00, 0x0A00};
			_fp.write( &lbstr[_lb-1], lblen[_lb-1] );
		}
		break;
	case UTF16l:    // Unicode  (UTF-16)  : BOML LE
	case UTF16LE:   // Unicode  (UTF-16LE): BOM
		{
			const int lblen[] = { 2, 2, 4 };
			// CR, LF, CRLF
			const USHORT lbstr[]={0x000D, 0x000A, 0x000D, 0x000A};
			_fp.write( &lbstr[_lb-1], lblen[_lb-1] );
		}
		break;
	}
}

char *TxtEncoder::alloc( int size )
{
	if ( size > _buffsize ){
		DELA( _buff );
		_buffsize = size+BUFF_BLOCK;
		_buff = new char[ _buffsize ];
	}
	return _buff;
}

void	TxtEncoder::writeLn(const TCHAR* s,int len)
{
	if ( len == 0 ){
		return;
	}
	switch( _charset ){
	case SJIS:
		{
			DWORD charlength = WideCharToMultiByte(CP_ACP, 0,s,len,NULL, 0, NULL, NULL);
			char* pChar = alloc(charlength+1);
			if ( pChar !=NULL ){
				WideCharToMultiByte(CP_ACP, 0, s,len, pChar, charlength, NULL, NULL);
				_fp.write( pChar, charlength );
				//DELA( pChar );
			}
		}
		break;
	case EucJP:
		{
			// ܂WCHARSJISɕϊ
			DWORD charlength = WideCharToMultiByte(CP_ACP, 0,s,len,NULL, 0, NULL, NULL);
			char* pChar = alloc(charlength+1);
			//char* pChar = new char [charlength+1];
			if ( pChar !=NULL ){
				WideCharToMultiByte(CP_ACP, 0, s,len, pChar, charlength, NULL, NULL);

				// SJIS->EUCɕϊ
				EucTxt	euc;
				int		euclen=0;
				char	*eucstr = euc.FromSjis( pChar, charlength , euclen );

				// ʂo
				_fp.write( eucstr, euclen );
				//DELA( pChar );
			}
		}
		break;
	case IsoJP:
		{
			// ܂WCHARSJISɕϊ
			DWORD charlength = WideCharToMultiByte(CP_ACP, 0,s,len,NULL, 0, NULL, NULL);
			char* pChar = alloc(charlength+1);
			//char* pChar = new char [charlength+1];
			if ( pChar !=NULL ){
				WideCharToMultiByte(CP_ACP, 0, s,len, pChar, charlength, NULL, NULL);

				// SJIS->EUCɕϊ
				Iso2022Txt	jis;
				int		jislen=0;
				char	*jisstr = jis.FromSjis( pChar, charlength , jislen );

				// ʂo
				_fp.write( jisstr, jislen );
				//DELA( pChar );
			}
		}
		break;
	case UTF8:
	case UTF8N:
		{
			DWORD charlength = WideCharToMultiByte(CP_UTF8, 0,s,len,NULL, 0, NULL, NULL);
			char* pChar = alloc(charlength+1);
			//char* pChar = new char [charlength+1];
			if ( pChar !=NULL ){
				WideCharToMultiByte(CP_UTF8, 0, s,len, pChar, charlength, NULL, NULL);
				_fp.write( pChar, charlength );
				//DELA( pChar );
			}
		}
		break;

	case UTF16b:    // Unicode  (UTF-16)  : BOML BE
	case UTF16BE:   // Unicode  (UTF-16BE): BOM
		{   // Big Endian
			for(int i=0;i<len;i++){
				USHORT c = (UCHAR)(s[i] >> 8) | ((s[i] & 0xff) << 8);
				_fp.write( &c, sizeof(USHORT) );
			}
		}
		break;
	case UTF16l:    // Unicode  (UTF-16)  : BOML LE
	case UTF16LE:   // Unicode  (UTF-16LE): BOM
		{   // Little Endian
			_fp.write( s, len*sizeof(wchar_t) );
		}
		break;
	case Latin:
		{
			DWORD charlength = WideCharToMultiByte(1252, 0,s,len,NULL, 0, NULL, NULL);
			char* pChar = alloc(charlength+1);
			if ( pChar !=NULL ){
				WideCharToMultiByte(1252, 0, s,len, pChar, charlength, NULL, NULL);
				_fp.write( pChar, charlength );
				//DELA( pChar );
			}
		}
		break;
	}
}


void TxtEncoder::writeLine(const TCHAR* s, int	len, 
						   bool firstline, bool lastline)
{
	// ŏ̍ŝƂBOMo
	if( firstline ) writeBOM();

	writeLn(s,len);

	// ŌɉsR[hB
	// AŏIsɂ͉s͂Ȃ
	if( !lastline ) writeLB();
}

